# File: InterfaceRule.py
# 
# Copyright (c) 2005 by eduplone Open Source Business Network EEIG, Austria
# Generator: ArchGenXML Version 1.4.0-RC1 devel 
#            http://plone.org/products/archgenxml
#
# German Free Software License (D-FSL), see LICENSE_D-FSL_1_0_en.txt
#
__author__  = '''Jens W. Klein <jens.klein@jensquadrat.com>, Daniel Nouri
<dpunktnpunkt@web.de>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.Hephaistos.interfaces.IRuleItem import IRuleItem
from Products.Hephaistos.StopChainProcessing import StopChainProcessing


from Products.Hephaistos.config import *
##code-section module-header #fill in your manual code here
from Products.CMFCore.utils import getToolByName
from Interface import Implements


def getPortalTypesByInterfaces(context, allowedIfaces):
    """Returns a list of portal type names of which the types implement any
    of the given interfaces.

    Note that allowedIfaces are strings, not Interfaces."""
    value = []
    tool = getToolByName(context, 'archetype_tool')
    for data in tool.listRegisteredTypes():
        kifaces = data['klass'].__implements__
        # We now flatten the interfaces and get their unqualified names,
        # e.g. <Products.FooBar.interfaces.ISpam> becomes "ISpam"
        kifaces = [str(iface.__name__)
                   for iface in Implements.flattenInterfaces((kifaces,))]
        if [iface for iface in allowedIfaces if iface in kifaces]:
            value.append(data['portal_type'])

    return value

##/code-section module-header

schema=Schema((
    LinesField('allowedInterfaces',
        widget=LinesWidget(
            label='Allowedinterfaces',
            label_msgid='Hephaistos_label_allowedInterfaces',
            description_msgid='Hephaistos_help_allowedInterfaces',
            i18n_domain='Hephaistos',
        )
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

InterfaceRule_schema = BaseSchema + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class InterfaceRule(BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (IRuleItem,)


    # This name appears in the 'add' box
    archetype_name             = 'InterfaceRule'

    meta_type                  = 'InterfaceRule'
    portal_type                = 'HephaistosInterfaceRule'
    allowed_content_types      = []
    filter_content_types       = 0
    global_allow               = 1
    allow_discussion           = 0
    #content_icon               = 'InterfaceRule.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "InterfaceRule"
    typeDescMsgId              = 'description_edit_interfacerule'

    schema = InterfaceRule_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #methods from Interface IRuleItem

    security.declarePublic('apply')
    def apply(self,**kwargs):
        """
        
        """
        portalType = kwargs['portalType']
        allowedInterfaces = self.getAllowedInterfaces()
        allowedTypes = getPortalTypesByInterfaces(self, allowedInterfaces)

        if not portalType in allowedTypes:
            raise StopChainProcessing, \
                  "%r does not implement any of %s" % (portalType, self.getAllowedInterfaces())


registerType(InterfaceRule,PROJECTNAME)
# end of class InterfaceRule

##code-section module-footer #fill in your manual code here
##/code-section module-footer



