# File: PortalTypeRule.py
# 
# Copyright (c) 2005 by eduplone Open Source Business Network EEIG, Austria
# Generator: ArchGenXML Version 1.4.0-RC1 devel 
#            http://plone.org/products/archgenxml
#
# German Free Software License (D-FSL), see LICENSE_D-FSL_1_0_en.txt
#
__author__  = '''Jens W. Klein <jens.klein@jensquadrat.com>, Daniel Nouri
<dpunktnpunkt@web.de>'''
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.Hephaistos.interfaces.IRuleItem import IRuleItem
from Products.Hephaistos.StopChainProcessing import StopChainProcessing


from Products.Hephaistos.config import *
##code-section module-header #fill in your manual code here
from Products.Archetypes.ArchetypeTool import listTypes
##/code-section module-header

schema=Schema((
    LinesField('allowedTypes',
        widget=MultiSelectionWidget(
            label='Allowedtypes',
            label_msgid='Hephaistos_label_allowedTypes',
            description_msgid='Hephaistos_help_allowedTypes',
            i18n_domain='Hephaistos',
        ),
        multiValued=1,
        vocabulary="allowedTypesVocabulary"
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

PortalTypeRule_schema = BaseSchema + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class PortalTypeRule(BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (IRuleItem,)


    # This name appears in the 'add' box
    archetype_name             = 'PortalTypeRule'

    meta_type                  = 'PortalTypeRule'
    portal_type                = 'HephaistosPortalTypeRule'
    allowed_content_types      = []
    filter_content_types       = 0
    global_allow               = 1
    allow_discussion           = 0
    #content_icon               = 'PortalTypeRule.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "PortalTypeRule"
    typeDescMsgId              = 'description_edit_portaltyperule'

    schema = PortalTypeRule_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

    security.declarePublic('allowedTypesVocabulary')
    def allowedTypesVocabulary(self):
        """
        
        """
        types = [fti['portal_type'] for fti in listTypes()]
        types.sort()
        return types


    #methods from Interface IRuleItem

    security.declarePublic('apply')
    def apply(self,**kwargs):
        """
        
        """
        portalType = kwargs['portalType']
        allowedTypes = self.getAllowedTypes()
        
        if not portalType in allowedTypes:
            raise StopChainProcessing, \
                  "%r not in %s" % (portalType, allowedTypes)


registerType(PortalTypeRule,PROJECTNAME)
# end of class PortalTypeRule

##code-section module-footer #fill in your manual code here
##/code-section module-footer



